function corners = FindCorners(Idx,Size,varargin)
%FINDEDLINES Summary of this function goes here
%   Detailed explanation goes here
    if nargin == 3
      if all(varargin{1}=='hough') 
        img = zeros(Size);
        img(Idx)=1;
        BW = edge(img,'sobel','nothinning');
        se = strel('disk',2);
        BW = imdilate(BW,se);
        [H,T,R]=hough(BW,'RhoResolution',1,'Theta',-90:0.1:89);
        P = houghpeaks(H,4,'threshold',ceil(0.3*max(H(:))));

        lines = houghlines(BW,T,R,P,'FillGap',150,'MinLength',50);

        A = zeros(4,2);
        for k = 1:length(lines)
            A(k,1)=k;
            A(k,2)=lines(k).theta;
        end
        A=sortrows(A,2);
        A=A([1,3,2,4]);
        PMat1 = ones(4,3);
        PMat2 = ones(4,3);

        PMat1(1:4,1:2) = cat(1,lines(A).point1);
        PMat2(1:4,1:2) = cat(1,lines(A).point2);


        Lines = cross(PMat1,PMat2);
        LinesShift = Lines([2,3,4,1],:);
        Pts = cross(Lines,LinesShift);
        corners = (Pts./Pts(:,3))';
      end
      else
        img = zeros(Size);
        img(Idx)=1;
        dimg = imgaussfilt(double(img),1.5);
        C = detectHarrisFeatures(dimg);
        C = C.selectStrongest(4);
        C = double(C.Location);
        C = sortrows([C,(C(:,1)-C(1,1)).^2+(C(:,2)-C(1,2)).^2],3);
        C(:,3)=1;
        C=C([1 2 4 3],:);
        corners = C';
    end

end

