function H = PtsCorTransf(PtsFrom, PtsTo)
%PTSCORTRANSF Summary of this function goes here
%   Detailed explanation goes here

polfrom = polyshape(PtsFrom(1:2,:)');
[cx,cy] = centroid(polfrom);
Tfrom = [1 0 -cx; 0 1 -cy;0 0 1];
tmp = Tfrom*PtsFrom;
avg = sum(sqrt(sum(tmp.^2)))/4;
R=[sqrt(2)/avg 0 0;0 sqrt(2)/avg 0;0 0 1];
T1 = R*Tfrom;
PtsFrom = T1*PtsFrom;

polfrom = polyshape(PtsTo(1:2,:)');
[cx,cy] = centroid(polfrom);
Tfrom = [1 0 -cx; 0 1 -cy;0 0 1];
tmp = Tfrom*PtsTo;
avg = sum(sqrt(sum(tmp.^2)))/4;
R=[sqrt(2)/avg 0 0;0 sqrt(2)/avg 0;0 0 1];
T2 = R*Tfrom;
PtsTo = T2*PtsTo;

A= zeros(9);
A(1:4,1)=PtsFrom(1,:);
A(1:4,2)=PtsFrom(2,:);
A(1:4,3)=1;
A(1:4,7)=-PtsFrom(1,:).*PtsTo(1,:);
A(1:4,8)=-PtsFrom(2,:).*PtsTo(1,:);
A(1:4,9)=-PtsTo(1,:);
A(5:8,4)=PtsFrom(1,:);
A(5:8,5)=PtsFrom(2,:);
A(5:8,6)=1;
A(5:8,7)=-PtsFrom(1,:).*PtsTo(2,:);
A(5:8,8)=-PtsFrom(2,:).*PtsTo(2,:);
A(5:8,9)=-PtsTo(2,:);

[~,~,V]=svd(A);
Hrow = V(:,end);
Hnn = reshape(Hrow,[3,3])';
H=(T2\Hnn)*T1;
end

